<template>
  <form class="form">
    <div class="link-wrapper">
      <the-link :link="formLabels.link" @click="switchForm" />
    </div>
    <h1 class="title">{{ formLabels.title }}</h1>
    <div class="login-wrapper">
      <the-input name="login" placeholder="Логин" :isError="isLoginError" :message="loginMessage" />
    </div>
    <div class="password-wrapper">
      <the-input type="password" name="password" placeholder="Пароль" :isError="isPasswordError"
        :message="passwordMessage" />
    </div>
    <div class="checkbox-wrapper">
      <check-box />
    </div>
    <div class="message-wrapper">
      <error-message v-show="isLoginOrPasswordError" :message="loginOrPasswordMessage" />
    </div>
    <div class="button-wrapper">
      <the-button :buttonText="formLabels.button" isOrange @click.prevent="handleButton" />
    </div>
  </form>
</template>

<script>
import { ref, computed, watch } from 'vue'
import { useStore } from 'vuex'
import { useRouter } from 'vue-router'
import CheckBox from '@/components/ui/CheckBox'
import ErrorMessage from '@/components/ui/ErrorMessage'
import TheButton from '@/components/ui/TheButton'
import TheInput from '@/components/ui/TheInput'
import TheLink from '@/components/ui/TheLink'

export default {
  components: {
    CheckBox, ErrorMessage, TheButton, TheInput, TheLink
  },
  setup () {
    const loginLabels = {
      link: 'Зарегистрироваться',
      title: 'Вход',
      button: 'Войти'
    }
    const registerLabels = {
      link: 'Авторизоваться',
      title: 'Регистрация',
      button: 'Зарегистрироваться'
    }
    const formLabels = ref(loginLabels)
    const router = useRouter()
    const store = useStore()
    const inputValues = computed(() => store.getters.GetInputValues)
    const inputLogin = computed(() => inputValues.value.login)
    const inputPassword = computed(() => inputValues.value.password)
    const isLoginError = ref(false)
    const loginMessage = ref('')
    const isPasswordError = ref(false)
    const passwordMessage = ref('')
    const isLoginOrPasswordError = ref(false)
    const loginOrPasswordMessage = 'Логин или пароль неверен'

    watch([inputLogin, formLabels], () => {
      isLoginError.value = false
      isLoginOrPasswordError.value = false
    })

    watch([inputPassword, formLabels], () => {
      isPasswordError.value = false
      isLoginOrPasswordError.value = false
    })

    const switchForm = () => {
      formLabels.value.title === loginLabels.title ? formLabels.value = registerLabels : formLabels.value = loginLabels
    }
    const validateForm = () => {
      if (!inputLogin.value) {
        isLoginError.value = true
        loginMessage.value = 'Поле не должно быть пустым'
      } else if (formLabels.value.title === registerLabels.title && inputLogin.value.length < 4) {
        isLoginError.value = true
        loginMessage.value = 'Логин должен содержать не менее 4-х символов'
      }
      if (!inputPassword.value) {
        isPasswordError.value = true
        passwordMessage.value = 'Поле не должно быть пустым'
      } else if (formLabels.value.title === registerLabels.title && inputPassword.value.length < 4) {
        isPasswordError.value = true
        passwordMessage.value = 'Пароль должен содержать не менее 4-х символов'
      }
      return !(isLoginError.value || isPasswordError.value)
    }
    const handleButton = () => {
      console.log('inputLogin', inputLogin.value)
      console.log('inputPassword', inputPassword.value)

      if (!validateForm()) return

      const users = localStorage.users ? JSON.parse(localStorage.users) : {}

      if (formLabels.value.title === registerLabels.title) {
        users[inputLogin.value] = inputPassword.value
        localStorage.users = JSON.stringify(users)
        switchForm()
        return
      }

      if (users[inputLogin.value] !== inputPassword.value) {
        isLoginOrPasswordError.value = true
        return
      }

      localStorage.isAuthorized = true
      router.push('/')
    }

    return {
      formLabels,
      switchForm,
      isLoginError,
      loginMessage,
      isPasswordError,
      passwordMessage,
      handleButton,
      isLoginOrPasswordError,
      loginOrPasswordMessage
    }
  }
}
</script>

<style lang="scss" scoped>
.form {
  width: 460px;
  height: 340px;
  background: #FFF;

  .link-wrapper {
    margin-top: 9px;
    margin-right: 20px;
    text-align: end;
  }

  .title {
    margin-top: 13px;
    text-align: center;
    font-family: Montserrat;
    font-size: 31px;
    font-weight: 700;
    text-transform: uppercase;
    color: #161516;
  }

  .login-wrapper {
    margin-top: 36px;
    margin-left: 20px;
  }

  .password-wrapper {
    margin-top: 4px;
    margin-left: 20px;
  }

  .checkbox-wrapper {
    margin-top: 3px;
    margin-left: 20px;
  }

  .message-wrapper {
    margin-top: 6px;
    height: 10px;
    text-align: center;
  }

  .button-wrapper {
    margin-top: 12px;
    text-align: center;
  }
}
</style>
